#include "VKString.h"
#include "Sortable.h"
#include "FileManagement.h"

#include "RendererGLUT.h"
#include "DatabaseVisWindow.h"
#include "ModelDatabase.h"
#include "ShapeTriangleSoup.h"

#include "STemplate.h"
#include "VisShapeTemplate.h"
#include "AppScreenshots.h"
#include "TMatch.h"
#include "RendererOSMesa.h"
#include "TMatchAlg.h"
#include "STemplateNode.h"


#ifndef __MatchHeaders_H
#define __MatchHeaders_H
void ReadModelNames(VKStringList & store, const VKString & filename);
STemplate * SingleTemplate(ModelDatabase * db, const VKString & mName, const VKString & geomName,
						   const VKString & labelsName, bool trustLabels, double useMeshThresh);

STemplate * InitTemplate(const VKString & topologyFile, const VKString & trainGeomName,
						 const VKString & trainLabelsName, ModelDatabase * db);

STemplate * ReadTemplateFromDir(const VKString & tmpltDir);

GeomShape * ReadModelGeometry(ModelDatabase * db, const VKString & mName, const VKString & geomName,
							  bool readManifold, const VKString & geomValue = "none" );
bool Equivalent(const VKString & label1, const VKString & label2, std::map<VKString, int> & label2ListID);
void ReadEquivalentLabels(const VKString & equivFile,
						  std::vector<VKStringList> & equivalenceList, std::map<VKString, int> & label2ListID);
VKString MainName(const VKString & label, std::vector<VKStringList> & equivalenceList, std::map<VKString, int> & label2ListID);
void EvalMatching(ModelDatabase * db, const TMatch * matching, const VKString & filename, const VKString & equivLabels);
void EvalFaces(ModelDatabase * db, const ShapeLabels * faceSegs, const VKString & filename,
			   const VKString & equivLabels, const VKString & evalPerNodeFile, TMatch * match);
void WriteAlignedModel(const TMatch * match, const VKString & filename);
void WriteTemplateMetaData(const STemplate * tmplt, const VKString & filename);

void WriteLabelsExternal(ModelDatabase * db, const TMatch * match, const VKString & dirName, const VKString & equivLabels);
ShapeValue * TransferWithGraphCut(TMatch * match, GeomShape * toShape);
ShapeValue * TransferFromPly(TMatch * match, GeomShape * toShape, const VKString & plyFile);

#endif
