/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __RendererOSMesa_H
#define __RendererOSMesa_H

#include <fstream>
#include <sstream>

#include "VisWindow.h"
#include "VKString.h"
#include "ParamParser.h"

#include "OpenGLHeaders.h"

using namespace std;

/**
 * Offscreen renderer (uses Mesa3D)
 */
class RendererOSMesa : public VisWindowRenderer
{
	public:
		RendererOSMesa(VisWindow * window);
		virtual void UpdateScreen();
		virtual void TerminateWindow();

	// helpers for VisWindow (framebuffer support)...
		virtual void CreateBuffer(BufferID & bufferID);
		virtual void LoadBuffer(BufferID & bufferID);
		virtual void FillDrawBuffer(BufferID & bufferID);
		
	
	
	protected:
		unsigned char * m_aOffscreenBuffer;
	
#ifdef MESA_RENDERING
		OSMesaContext m_MesaContext;
#endif

};

#endif
