/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#include "DBApp.h"

DBApp::DBApp(ModelDatabase * db, DBCorrs * dbCorrs)
{
	m_pDB = db;
	m_pDBCorrs = dbCorrs;
	m_iVisFlags = 0;
	m_bDisable = false;
}

DBApp::~DBApp()
{
	
}

bool DBApp::KeyPressed(DatabaseVisWindow * window, const char key, int mouseX, int mouseY)
{
	return false;
}

bool DBApp::MouseButtonEvent(DatabaseVisWindow * window, 
							 int x, int y, VisWindow::MouseButton mouseButtonID, 
							 VisWindow::MouseButtonState newState)
{
	return false;
}

bool DBApp::MouseMotionEvent(DatabaseVisWindow * window, int x, int y, int dx, int dy)
{
	return false;
}

bool DBApp::Draw(DatabaseVisWindow * window)
{
	return false;
}

void DBApp::SetScreenshotType(const VKString & sName, int value)
{
	SetRenderingFlags(value);
}

int DBApp::GetRenderingFlags() const
{
	return m_iVisFlags;
}

void DBApp::SetRenderingFlags(int flags)
{
	m_iVisFlags = flags;
}

void DBApp::SetRenderingFlag(int flag, bool value)
{
	if (value != IsFlagSet(flag))
		Toggle(flag);
		
}

void DBApp::Toggle(int flag)
{
	if (IsFlagSet(flag))
		m_iVisFlags &= (~flag);
	else
		m_iVisFlags |= flag;
}

bool DBApp::IsFlagSet(int flag) const
{
	return (m_iVisFlags & flag);
}

void DBApp::ToggleDisable()
{
	m_bDisable = !m_bDisable;
}
