#!/usr/bin/python

##
# Learns a set of deformable templates from a collection (needs an initial template)
#
import os, sys;
sys.path.append(os.path.realpath("./"+os.path.dirname(sys.argv[0])+"/scripts/largescale/"))
import mydb;

workDir = "./scratch"
if len(sys.argv)>=4:
	tmplt = sys.argv[1]
	dbdir = sys.argv[2]
	outdir = sys.argv[3]
	i = 4;
	while i<len(sys.argv):
		if (sys.argv[i]=="-workDir"):
			i = i + 1;
			workDir = sys.argv[i];
		i = i + 1;

else:
	print("Usage:")
	print("   learnTmplt.py init.tmplt collection_dir out_dir [optional]");
	print("Optional:");
	print("    -workDir dir - working directory (default=./scratch)");
	exit()

# prepare collection
if os.path.isdir(workDir):
	os.system("rm -r -f "+workDir);
os.system("mkdir "+workDir);

os.system("./scripts/largescale/createFromDir.py "+dbdir+" "+workDir+"/");
os.system("./scripts/largescale/createAllPointSets.py "+workDir+" 1000");

# analyze collection
cmd = "./scripts/evolution/evolve.py "+workDir+" "+tmplt+" evolve ";
os.system(cmd);

# export results
cmd = "./exportAnalysis.py "+workDir+" "+workDir+"/Templates/evolve_GenFinal "+outdir;
os.system(cmd);
#os.system("cp "+workDir+"/Templates/"+workDir+"_GenFinal/main.tmplt "+outFile);






