#!/usr/bin/python

##########
# For every model in a directory in Processing/$keyword
#	extract evenly distributed point set
##########

import os, re, subprocess, shlex, sys, datetime, glob, string, mydb

writeScheduledIDs = "none";
if len(sys.argv)>=3:
	keyword	= sys.argv[1]
	nPoints	= sys.argv[2]
else:
	print("Usage: ")
	print("    python "+str(sys.argv[0])+" keyword nPnts [options]")
	print(" -writeScheduledIDs file");
	exit()

fName="Even"+str(nPoints);
processOnce = True;

modelsList=mydb.ListModels(keyword)
dbDir=mydb.MyDBDir(keyword)

# go over all models
currFile=0
nFiles = len(modelsList)

nProcessed = 0;
print("Processing directory: "+keyword)
jobids = [];
for filename in modelsList:
	if ((currFile%100)==0):
		print("     File "+str(currFile)+" / "+str(nFiles));
	currFile = currFile + 1
	
	nameOnly = mydb.NameOnly(filename)	
	outFile = mydb.GeometryDir(keyword, nameOnly)+"/main_"+fName+".pnts";
	# check if allows double processing or if file does not exist
	if not processOnce or not os.path.isfile(outFile):
		cmd="./FindPoints "+dbDir +" -model "+nameOnly + " -writeGeometry";
		cmd+= " -type IterFar eucl -npoints "+str(nPoints) + " -pntsName "+fName;
		jobids.append(mydb.ExecuteNoWait(cmd, nameOnly+"_"+fName));
	else:
		nProcessed = nProcessed + 1;

if writeScheduledIDs!="none":
	mydb.WriteJobsFile(jobids, writeScheduledIDs);

print("Processed "+str(nFiles))
print("Were Processed "+str(nProcessed))
