<?php
{
	function strPercent($val1, $val2)
	{
		$val1 = floatval($val1);
		$val2 = floatval($val2);
		if ($val1==0)
			return "0%";
		elseif ($val2==0)
			return "inf";
		else
		{
			$ipart = intval(100.*$val1/$val2);
			$dpart = intval(10000.*$val1/$val2)%100;
			return "".$ipart.".".$dpart."%";
		}
	}
	function thumbName($dataset, $model)
	{
		$currDir = thumbDir($dataset, $model);
  		if (is_dir($currDir))
		{
			if (is_file($currDir."/Textured.jpg"))
				return $currDir."/Textured.jpg";
			elseif (is_file($currDir."/WholeModel.jpg"))
				return $currDir."/WholeModel.jpg";
			elseif (is_file($currDir."/thumb.jpg"))
				return $currDir."/thumb.jpg";
			else
				return "none";
		}
		else
			return "none";
	} 
	
	function thumbDir($dataset, $model)
	{
		$model=trim($model);
		$currDir = "../data/".$dataset."/meta/".$model."/";
		return $currDir;
	}
	
	function getImgTag($imgFile, $maxDim)
	{
		if (file_exists($imgFile))
		{
			list($width, $height) = getimagesize($imgFile);
			if ($width > $height)
				return "<img width=".$maxDim." src=\"".$imgFile."\">";
			else
				return "<img height=".$maxDim." src=\"".$imgFile."\">";
		}
		else
			return "<img src=".$imgFile.">";
	}
	
	function thumbImg($dataset, $model)
	{
		$thumb = thumbName($dataset, $model);
		if ($thumb=="none")
			return $model;
		else
		{
			return getImgTag($thumb, 100);
		}
	}
	
	function thumbImgUrlText($dataset, $model)
	{
		$thumb = thumbName($dataset, $model);
		if ($thumb=="none")
			return $model;
		else
		{
			$url="viewmodel.php?dataset=".$dataset."&model=".$model;
			return "<a href=\"".$url."\">".thumbImg($dataset, $model)."</a><br>".$model;
		}
	}

}
?>