// Include file for R3 harmonics module 

#ifndef __R3__HARMONICS__H__
#define __R3__HARMONICS__H__



// Dependency include files 

#include "R3Shapes/R3Shapes.h"



// Forward class declarations

class R2SphericalGrid;
class R2SphericalHarmonics;
class R3SphericalGrid;
class R3SphericalHarmonics;



// Spharmonickit stuff

#include "R3Harmonics/indextables.h"
#include "R3Harmonics/permroots.h"
#include "R3Harmonics/utils.h"
#include "R3Harmonics/csecond.h"
#include "R3Harmonics/oddweights.h"
#include "R3Harmonics/weights.h"
#include "R3Harmonics/newFCT.h"
#include "R3Harmonics/cospmls.h"
#include "R3Harmonics/OURperms.h"
#include "R3Harmonics/OURmods.h"
#include "R3Harmonics/fft_grids.h"
#include "R3Harmonics/makeWigner.h"
#include "R3Harmonics/wignerTransforms.h"
#include "R3Harmonics/naive_synthesis.h"
#include "R3Harmonics/FFTcode.h"
#include "R3Harmonics/primitive.h"
#include "R3Harmonics/primitive_FST.h"
#include "R3Harmonics/seminaive.h"
#include "R3Harmonics/FST_semi_memo.h"
#include "R3Harmonics/FST_SO3.h"
#include "R3Harmonics/MathFace.h"



// 2D Grid include files 

#include "R3Harmonics/R2SphericalGrid.h"
#include "R3Harmonics/R2SphericalHarmonics.h"



// 3D Grid include files 

#include "R3Harmonics/R3SphericalGrid.h"
#include "R3Harmonics/R3SphericalHarmonics.h"



// Utility include files

#include "R3Harmonics/R3WignerD.h"
#include "R3Harmonics/R3Align.h"



// Initialization functions 

int R3InitHarmonics(void);
void R3StopHarmonics(void);



#endif











