/***************************************************************************
  **************************************************************************
  
                SOFT: SO(3) Fourier transform code
  
   Peter Kostelec, Dan Rockmore
   {geelong,rockmore}@cs.dartmouth.edu
  
   Contact: Peter Kostelec
            geelong@cs.dartmouth.edu
  
  
   Copyright 2003 Peter Kostelec, Dan Rockmore
  
  
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
  
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
  
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  
   Commercial use is absolutely prohibited.
  
   See the accompanying LICENSE file for details.
  
  ************************************************************************
  ************************************************************************/



/*

  header file for basic utility functions

  vec_add() - add two vectors together
  vec_mul() - multiply vector by a scalar
  vec_pt_mul() - pointwise-multiply two vectors

  as well as declaring some macros
*/


#ifndef _UTILS_H
#define _UTILS_H 1


#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif    /* M_PI */

#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define MIN(A, B) ((A) > (B) ? (B) : (A))
#define ABS(A) ((A) > 0 ? (A) : (-A))


extern void vec_add( double * ,
		     double * ,
		     double * ,
		     int ) ;

extern void vec_mul( double ,
		     double * ,
		     double * ,
		     int ) ;

extern void vec_pt_mul( double * ,
			double * ,
			double * ,
			int ) ;

extern double vec_inner( double * ,
			 double * ,
			 int ) ;

extern void transpose( double * ,
		       double * ,
		       int ,
		       int ) ;

extern int totalCoeffs( int ) ;

extern int numCoeffs( int ,
		      int ) ;

extern int howMany( int ,
		    int ,
		    int ) ;

#endif /* _UTILS_H */
