// Include file for rotation alignment functions



// Utility functions for parsing rotational alignment of grids

void R3EulerRotationIndices(int index, int size, int& i, int& j, int& k);
void R3EulerRotationAngles(int i, int j, int k, int size, R3Vector& euler_angles);
void R3EulerRotationAngles(int index, int size, R3Vector& euler_angles);
void R3EulerRotationMatrix(const R3Vector& euler_angles, R4Matrix& rotation_matrix);
void R3EulerRotationMatrix(int i, int j, int k, int size, R4Matrix& rotation_matrix);
void R3EulerRotationMatrix(int index, int size, R4Matrix& rotation_matrix);



// Utility functions for computing rotational alignment of grids

RNInterval R2CorrelationForAllRotations(const R2SphericalHarmonics& harmonics1, const R2SphericalHarmonics& harmonics2, 
  double *euler_grid = NULL, int *min_correlation_index = NULL, int *max_correlation_index = NULL);
RNInterval R2CorrelationForAllRotations(const R2SphericalGrid& grid1, const R2SphericalGrid& grid2,
  double *euler_grid = NULL, int *min_correlation_index = NULL, int *max_correlation_index = NULL);

RNInterval R3CorrelationForAllRotations(const R3SphericalHarmonics& harmonics1, const R3SphericalHarmonics& harmonics2, 
  double *euler_grid = NULL, int *min_correlation_index = NULL, int *max_correlation_index = NULL);
RNInterval R3CorrelationForAllRotations(const R3SphericalGrid& grid1, const R3SphericalGrid& grid2,
  double *euler_grid = NULL, int *min_correlation_index = NULL, int *max_correlation_index = NULL);
RNInterval R3CorrelationForAllRotations(const R3Grid& grid1, const R3Grid& grid2,
  double *euler_grid = NULL, int *min_correlation_index = NULL, int *max_correlation_index = NULL);
