//
// $Id: Runtime.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __RUNTIME_H
#define __RUNTIME_H

#include "R3Graphics/R3Graphics.h"
#include "R3Groupn.h"
#include "VrmlNode.h"
#include "DEFTable.h"
#include "WallTimer.h"






class Event {

public:

  Event() {};
  Event(VrmlNode *new_source, int new_source_id,
	VrmlNode *new_dest, int new_dest_id) {
    source = new_source;
    dest = new_dest;
    source_field_id = new_source_id;
    dest_field_id = new_dest_id;
  }  // constructor

  ~Event() {}


  VrmlNode *get_source_ptr() { return source; }
  VrmlNode *get_dest_ptr() { return dest; }
  int get_source_id() { return source_field_id; }
  int get_dest_id() { return dest_field_id; }

  
private:

  VrmlNode *source;
  VrmlNode *dest;
  int source_field_id;
  int dest_field_id;

};  // Event class





class EventQueue {

public:

  EventQueue() {}
  ~EventQueue() {
    int nr_events = queue.NEntries();
    for(int i=0; i<nr_events; i++) delete queue.Kth(i);
  }  // destructor


  void add_event(Event *new_event);
  int process_events();


private:

  RNQueue<Event *> queue;

};  // EventQueue class





#include "Sensors.h"

class TimeSensorList
{

public:

  TimeSensorList() {}
  ~TimeSensorList() {}


  void add_timesensor(TimeSensor *new_timesensor);
  int send_updates();


private:

  RNArray<TimeSensor *> timesensors;


};  // TimeSensorList class





class TouchSensorList
{

public:

  TouchSensorList() {}
  ~TouchSensorList() {}


  void add_touchsensor(TouchSensor *new_touchsensor);
  int click(int down);


private:

  RNArray<TouchSensor *> touchsensors;


};  // TouchSensorList class





//
// Globals
//

extern RNArray<R3GroupNode *> group_stack;
extern TimeSensorList timesensors;
extern TouchSensorList touchsensors;
extern EventQueue event_queue;
extern DEFTable my_DEF_table;
extern WallTimer global_timer;


#endif


