//
// $Id: Script.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __Script_H
#define __Script_H

#include "VrmlNode.h"
#include "Fields.h"
#include "VrmlScript.h"
#include "VsSymbolTable.h"





class Script : public VrmlNode
{

public:

  Script() : VrmlNode() { 
    set_node_name("Script");
    set_node_type(ScriptType);

    add_field("url", &url, exposedField);
    add_field("directOutput", &directOutput, field);
    add_field("mustEvaluate", &mustEvaluate, field);

    directOutput.set_boolean(FALSE);
    mustEvaluate.set_boolean(FALSE);

    url_filename = NULL;
    vrmlscript_ptr = NULL;

  }  // constructor

  ~Script() {
    if (url_filename) delete url_filename;
    if (vrmlscript_ptr) delete vrmlscript_ptr;
  }  // destructor


  void parse();
  void add_Ring();

  USE_ActionType get_USE_action() { return ReturnVrmlNode; }

  void sendEventIn(int field_id, void *new_value);


private:

  MFString url;
  // used to store where the url field is (which file and which line nr)
  // so when there are VrmlScript errors, a meaningful message can be given
  int url_line_nr;
  char *url_filename;
  SFBool directOutput;
  SFBool mustEvaluate;

  void parse_field(char *field_type);

  void parse_url();

  VrmlScript *vrmlscript_ptr;


};  // Script class


#endif
