//
// $Id: VrmlScript.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __VRMLSCRIPT_H
#define __VRMLSCRIPT_H

#include "Files.h"
#include "R3Nodes/R3Nodes.h"
#include "VsSymbolTable.h"

static char *vrmlscript_symbol_chars = "\"'#+,-[]\\{}()=;*/<>!~%&|^";
static char *vrmlscript_whitespace_chars = " \t\n";





class VrmlScript
{

public:

  VrmlScript();
  VrmlScript(char *new_source);

  ~VrmlScript() {
    if (scriptfile) delete scriptfile;
    if (source_info) delete source_info;
  }  // destructor


  void parse();
  void execute(char *function_id, int argc, Field **argv);

  void set_source_info(char *filename, int line_nr);


private:

  char *source;
  VrmlFile *scriptfile;

  char *source_info;

  VsSymbolTable functions;


};  // VrmlScript class


#endif
