//
// $Id: VsSymbolTable.C,v 1.1 2000/01/17 18:47:40 min Exp min $
//

#include "VsSymbolTable.h"
#include "VsExprNodes.h"

VsSymbolTable *cur_symbol_table = NULL;





VsSymbolTable::VsSymbolTable(VsSymbolTable& other)
{
  int nr_symbols = other.get_size();

  for(int i=0; i<nr_symbols; i++) {
    VsSymbolNode *symbol_ptr = other[i]->create_copy();
    add(symbol_ptr);
  }  // for

}  // VsSymbolTable copy constructor



VsSymbolTable::~VsSymbolTable()
{
  int nr_symbols = symbols.NEntries();
#ifdef __DEBUG_DESTRUCTORS__
  cout << "VsSymbolTable destructor, " << nr_symbols << " symbols" << endl;
#endif
}  // destructor



VsSymbolNode *
VsSymbolTable::find_symbol(char *id)
{
  int nr_symbols = get_size();

  for(int i=0; i<nr_symbols; i++) {
    if (strcmp(id, symbols.Kth(i)->get_name()) == 0)
      return symbols.Kth(i);
  }  // for

  return NULL;

}  // VsSymbolTable::find_symbol



int
VsSymbolTable::get_symbol_index(char *id)
{
  int nr_symbols = symbols.NEntries();

  for(int i=0; i<nr_symbols; i++) {
    if (strcmp(id, symbols.Kth(i)->get_name()) == 0)
      return i;
  }  // for

  return -1;

}  // VsSymbolTable::get_symbol_index



void
VsSymbolTable::store_state()
{
  states_stored.Insert(get_size());
}  // VsSymbolTable::store_state



void
VsSymbolTable::restore_state()
{
  if (states_stored.NEntries() == 0) {
    cerr << "Error: VsSymbolTable::restore_state called before store_state"
      << endl;
    return;
  }

  int cur_size = get_size();
  int to_be_removed = cur_size - states_stored.Tail();
  for(int i=0; i<to_be_removed; i++) remove_tail();
  states_stored.RemoveTail();

}  // VsSymbolTable::restore_state



Field *
VsSymbolTable::handle_IS()
{
  char token[MAX_TOKEN_LENGTH];

  cur_vrml_file->get_token(token);

  VsVariableNode *symbol_ptr = (VsVariableNode *) find_symbol(token);
  if (symbol_ptr) return symbol_ptr->get_field_ptr();
  return NULL;

}  // VsSymbolTable::handle_IS

