//
// $Id: VsSymbolTable.h,v 1.1 2000/01/17 18:47:59 min Exp min $
//

#ifndef __VSSYMBOLTABLE_H
#define __VSSYMBOLTABLE_H

#include "R3Shapes/R3Shapes.h"
#include "VsSymbolNode.h"

class VsSymbolTable;
extern VsSymbolTable *cur_symbol_table;





class VsSymbolTable
{

public:

  VsSymbolTable() {}
  VsSymbolTable(VsSymbolTable& other);
  ~VsSymbolTable();


  VsSymbolNode *find_symbol(char *id);
  int get_symbol_index(char *id);
  VsSymbolNode *operator[](int index) { return symbols.Kth(index); }
  int get_size() { return symbols.NEntries(); }

  void add(VsSymbolNode *var_node_ptr) { symbols.Insert(var_node_ptr); }
  void remove_tail() { symbols.RemoveTail(); }
  void remove_head() { symbols.RemoveHead(); }

  void store_state();
  void restore_state();

  Field *handle_IS();


private:

  RNArray<VsSymbolNode *> symbols;

  RNArray<int> states_stored;  // need an array because of multiple PROTOs


};  // VsSymbolTable class


#endif

